<?php

/**
 * log_general actions.
 *
 * @package    canon
 * @subpackage log_general
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class log_generalActions extends sfQuery {

    protected $table_names = array(
        'CA_LOG',
        'CA_MAE_BD',
        'CA_ACCESO',
        'CA_OPE_BD',
        'CA_USUARIO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CA_MAE_BD,LEFT' =>
        array(
            'id_mae_bd' => 'CA_LOG'
        ),
        'CA_ACCESO,LEFT' =>
        array(
            'cod_func' => 'CA_LOG'
        ),
        'CA_OPE_BD,LEFT' =>
        array(
            'id_ope_bd' => 'CA_LOG'
        ),
        'CA_USUARIO,LEFT' =>
        array(
            'id_usuario' => 'CA_LOG'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_LOG' =>
        array(
            'id_log' => 'id_log',
            'id_tabla' => 'id_tabla',
            'vigencia' => 'vigencia',
            'periodo' => 'periodo',
            'fecha_log' => 'fecha_log',
            'id_ope_bd' => 'id_ope_bd',
            'id_mae_bd' => 'id_mae_bd',
            'id_usuario' => 'id_usuario',
            'cod_func' => 'cod_func',
            'observacion' => 'observacion' 
        ),
        'CA_MAE_BD' =>
        array(
            'des_mae_bd' => 'des_mae_bd'
        ),
        'CA_ACCESO' =>
        array(
            'es_funcion' => 'es_funcion',
            'rotulo' => 'rotulo'
        ),
        'CA_OPE_BD' =>
        array(
            'des_ope_bd' => 'des_ope_bd'
        ),
        'CA_USUARIO' =>
        array(
            'username' => 'username',
            'estado' => 'estado'
        )
    );
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * BETWEENFECHA - para filtrar entre fechas y no tener encuenta la hora - ejemplo: where to_char(campo, 'YYYY-MM-DD') between x and y
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CA_LOG' =>
        array(
            'id_log' => array('!=' => array(-1)),
            'id_tabla' => array('=' => array('noRegistro')),
            'vigencia' => array('=' => array('vigencia')),
            'periodo' => array('=' => array('periodo')),
            'fecha_log' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_ope_bd' => array('=' => array('id_ope_bd')),
            'id_mae_bd' => array('=' => array('id_mae_bd')),
            'id_usuario' => array('=' => array('id_usuario')),
            'cod_func' => array('=' => array('comando_informe')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CA_USUARIO' =>
        array(
            'username' => array('=' => array('username'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'CA_LOG' =>
        array(
            'observacion' => array('LIKEALLPLUS' => array('observacion', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_log'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    //false - Registrar log para list - consultar
    protected $log_list = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
